
function moveGroup(fromNode, fromGroup, toGroup) {

  $.get("/public/callapiasuser?call=mypage/movenode&nodeId="+fromNode+"&toGroupId="+toGroup, function(data) {
    if (data == "OK") {

      var lastId = 'mycat-section-1';
      var hasOther = ($('#' + lastId).attr('group') == toGroup);

      $('#catgroup-' + toGroup).append($('#mycat-section-' + fromNode));

      // If the destination group has the "Other links" category
      // then make sure that non-movable category remains last in the group

      if (hasOther) { $('#catgroup-' + toGroup).append($('#' + lastId)); }

      var section = $('#mycat-section-' + fromNode);

      section.attr('group', toGroup);
      section.find('[group=' + fromGroup + ']').attr('group', toGroup);

      hideEdgeCategoryIcons(fromGroup);
      hideEdgeCategoryIcons(toGroup);
    } else alert("move node "+ fromNode +" from group "+ fromGroup +" to group "+ toGroup +" : "+ data);
  });
}

function openGroup(groupId) {

  // Hide all groups initially, make their tabs inactive,
  // and hide all 'make me the default' group icons
  $('.mygroups').hide();
  $(`.groupTab`).removeClass("active");
  $('i.defaultGroupIcon.far').hide();

  // Now show the group specified by groupId, mark its tab as active,
  // and show its default group icon
  $(`#group${groupId}`).show();
  $(`#groupTab${groupId}`).addClass("active");
  $(`#groupTab${groupId} i`).show();

  // If the active tab is not fully showing, scroll to it
  let activeTab = $(`#groupTab${groupId}`);
  let editTabWidth = 130;
  if ((activeTab.position().left + activeTab.width()) > window.innerWidth) {
    $('#groupTabs').animate({scrollLeft: activeTab.position().left - editTabWidth}, 500);
  }

  // If there are no user-saved categories (no edit-cat icons)
  // and Other links is not in this group or it's empty
  // then show the help

  const noCats     = $(`#group${groupId} i.edit-cat`).length == 0;
  const noOther    = $(`#group${groupId} i.otherLinks`).length == 0;
  const otherEmpty = $(`#catgroup-${groupId} i.editSite`).length == 0;

  if (noCats && (noOther || otherEmpty)) { $('#mypage-help').show(); }
  else                                   { $('#mypage-help').hide(); }
}

function addGroup() {
  if ( $("#typegrouptitle").val().length > 0) {
    $("#addgrouptitle").val($("#typegrouptitle").val());
    $("#addgrouppublic").val($("#checkgroupprivacy").is(":checked")?'1':'0');
    $("#newGroupForm").submit();
  }
}      

function removeGroup(groupId) {
  window.location.replace("/public/mypageedit?delgroup="+groupId);
}

function editname(nodeId) {

  let activeNode   = '.editname[node=' + nodeId + ']';
  let activeHeader = '#mycat-header-' + nodeId;

  $(activeNode).toggle();

  // (un)set background so it's correct even if I hover away
  if ($(activeNode).css("display") == "none") {
    $(activeHeader).css({ 'background':'' });
  }
  else {
    $(activeHeader).css({ 'background':'#eee' });
  }
}

function closeNodeEditForm(nodeId) { 
  $('.editname[node=' + nodeId + ']').hide();
  $("#mycat-header-"+nodeId).css({ 'background':'' });
}

function removeNodeFromGroup(nodeId, groupId) {
  window.location.replace("/public/mypageedit?delnode="+nodeId+"&groupId="+groupId);
}

function removeURLfromGroup() {
  urlId   = $('#updateUrlId').val();
  groupId = $('#updateUrlGroupId').val();
  window.location.replace("/public/mypageedit?delurl="+urlId+"&groupId="+groupId);
}

function openUrlEditForm(nodeId,id,groupId) {
  $("#urlformtitle").html(editLinkText);
  $("#updateUrlGroupId").val(groupId);
  $("#updateUrlId").val(id);
  $("#updateNodeId").val(nodeId);
  $("#editurl").val(url[id][0]);
  $("#edittitle").val(url[id][1]);
  $("#editdesc").val(url[id][2]);
  $("#urlformsubmit").val(updateButtonText);
  $("#urlformdelete").show();
  $("#urlEditForm").show();
}

function openUrlAddForm(nodeId,groupId) {
  $("#urlformtitle").html(addLinkText);
  $("#updateNodeId").val(nodeId);
  $("#updateUrlGroupId").val(groupId);
  $("#updateUrlId").val(0);
  $("#editurl").val('');
  $("#edittitle").val('');
  $("#editdesc").val('');
  $("#urlformsubmit").val(addButtonText);
  $("#urlformdelete").hide();
  $("#urlEditForm").show();
}

function closeUrlEditForm() {
  $("#urlEditForm").hide();
}

function hideEdgeMoveIcons() {

  // Start off making all of the move icons visible
  $('.myGroupMoveIcon').removeClass('invisible');

  // Make the move-left icon invisible on the left-most group
  leftMost = $('.movableTab').first().attr('id').replace('groupTab','');
  $('#left-of-' + leftMost).addClass('invisible');
 
  // Make the move-right icon invisible on the right-most group
  rightMost = $('.movableTab').last().attr('id').replace('groupTab','');
  $('#right-of-' + rightMost).addClass('invisible');
}

function hideEdgeCategoryIcons(catGroup) {

  // Start off making all of the given group's move icons visible
  $('i.myCatMoveIcon[group=' + catGroup + ']').removeClass('invisible');

  // Make the move-up icon invisible on the top group
  topMost = $('.movableCatGroup[group=' + catGroup + ']').first().attr('node');
  $('#up-from-' + topMost).addClass('invisible');
 
  // Make the move-down icon invisible on the bottom group
  bottomMost = $('.movableCatGroup[group=' + catGroup + ']').last().attr('node');
  $('#down-from-' + bottomMost).addClass('invisible');
}

$(document).ready(function() {

  // Allow popup forms to be repositioned (dragged)
  $( ".form-popup" ).draggable();

  // Allow categories to be dragged and dropped into new groups
  $( ".draggable-cat.icon-plus-catname" ).draggable({ 
      revert: "invalid", 
      helper: "clone",
      handle: "i.cat-bullet",
      zIndex: 100,
      cursor: "move",
      cursorAt: { left: 25, top: -11 }
    });

  $( ".droppable-cat" ).droppable({
      accept: ".draggable-cat",
      tolerance: "pointer",
      classes: {
        "ui-droppable-active": "ui-state-active",
        "ui-droppable-hover": "ui-state-hover"
      },
      drop: function(event, ui) {
        var fromNode  = ui.draggable.attr("node");
        var fromGroup = ui.draggable.attr("group");
        var toId      = event.target.id;
        var toGroup   = $('#' + toId).attr('group');

        if ( fromGroup != toGroup ) {
          console.log( "drag node: " + fromNode + " from group: " + fromGroup + " to: " + toGroup);

          moveGroup(fromNode, fromGroup, toGroup);
        }
      }
    });

  $('.addNewGroup').on('click', function(event) {
    event.preventDefault();  // let addGroup do the submit if appropriate
    addGroup();
  });

  // If the move-right icon was clicked,
  // move the next group tab before the chosen group tab
 
  $('i.myGroupMoveIcon.move-right').on('click', function(event) {
    var myId = this.id,
        tabId = myId.replace('right-of-', 'groupTab'),
        groupId = myId.replace('right-of-','');

    $.get("/public/callapiasuser?call=mypage/movegroupright&groupId="+groupId,function(data) {
        if (data=="OK") {
            var swapWith = $('#' + tabId).next();
            $('#' + tabId).before(swapWith);
            hideEdgeMoveIcons();
            markDefaultGroup();  // in case we have a new inferred default
        } else alert("move group" + groupId+" right: "+data);
    });
  });

  // If the move-left icon was clicked,
  // move the previous group tab after the chosen group tab
 
  $('i.myGroupMoveIcon.move-left').on('click', function(event) {
    var myId    = this.id,
        tabId   = myId.replace('left-of-', 'groupTab'),
        groupId = myId.replace('left-of-','');

    $.get("/public/callapiasuser?call=mypage/movegroupleft&groupId="+groupId,function(data) {
        if (data=="OK") {
            var swapWith = $('#' + tabId).prev();
            $('#' + tabId).after(swapWith);
            hideEdgeMoveIcons();
            markDefaultGroup();  // in case we have a new inferred default
        } else alert("move group" + groupId+ "left: "+data);
    });
  });

  // If the move-down icon was clicked,
  // move the next group tab before the chosen group tab
 
  $('i.myCatIcon.move-down').on('click', function(event) {
    var myId = this.id,
        catId = myId.replace('down-from', 'mycat-section'),
        nodeId = myId.replace('down-from-','');
        catGroup = $('#' + catId).attr('group');

    $.get("/public/callapiasuser?call=mypage/movenodedown&nodeId="+nodeId, function(data) {
        if (data=="OK") {
            var swapWith = $('#' + catId).next();
            $('#' + catId).before(swapWith);
            hideEdgeCategoryIcons(catGroup);
        } else alert("move category " + nodeId + " down: " + data);
    });
  });

  // If the move-up icon was clicked,
  // move the previous group tab after the chosen group tab
 
  $('i.myCatIcon.move-up').on('click', function(event) {
    var myId = this.id,
        catId = myId.replace('up-from', 'mycat-section'),
        nodeId = myId.replace('up-from-','');
        catGroup = $('#' + catId).attr('group');

    $.get("/public/callapiasuser?call=mypage/movenodeup&nodeId="+nodeId, function(data) {
        if (data=="OK") {
            var swapWith = $('#' + catId).prev();
            $('#' + catId).after(swapWith);
            hideEdgeCategoryIcons(catGroup);
        } else alert("move category " + nodeId + " up: " + data);
    });
  });

  $('#groupEditTab').on('click', function () {
    event.preventDefault();
    if ($('#mypage-body').offset().top < 130) {
      $("html, body").animate({ scrollTop: 65 }, 500);
    }
    $('.mypage-managegroup').toggle();  // between hide and show
  });

  $('.closeGroupEdit').on('click', function (event) {
    $('.mypage-managegroup').hide();
    event.preventDefault();
  });

  $('#groupAddTab').on('click', function () {

    if ($('#groupAddTab').hasClass('closed')) {
      $('.group-add-closeable').removeClass('closed');
      $('#typegrouptitle').focus();
    }
    else {
      $('#groupAddTab').css({ 'background': '' });
      $('.group-add-closeable').addClass('closed');
    }

    if (! $('#group-tab-inner').hasClass('scroll-group-tab')) {
      $('#newGroupPanel').css({ 'top': 80 + $('#mypage-top').height() });
    }
  });

  // If the group open/close tab icon was clicked,
  // then open/close all categories and have icons match

  $('#groupOCTab').on('click', function () {
    $('i.openCloseAllIcon').toggleClass('closed');
    var isClosed = $('i.openCloseAllIcon').hasClass('closed');
    $('i.cat-bullet').toggleClass('fas', isClosed);  /* switch between solid */
    $('i.cat-bullet').toggleClass('far', !isClosed); /* and outline          */
    $('i.cat-bullet').toggleClass('closed', isClosed);
    $('.mycat-site-content').toggleClass('closed', isClosed);
  });  

  $('.edit-cat').on('click', function () {
    editname($(this).attr('node'));
  });

  $('.add-to-cat').on('click', function () {
    openUrlAddForm($(this).attr('node'), $(this).attr('group'));
  });

  $('.delete-cat').on('click', function () {
    removeNodeFromGroup($(this).attr('node'), $(this).attr('group'));
  });

  $('.cancel-cat-edit').on('click', function (event) {
    closeNodeEditForm($(this).attr('node'));
    event.preventDefault();
  });

  $('.editSite').on('click', function () {
    openUrlEditForm($(this).attr('node'), $(this).attr('url'), $(this).attr('group'));
  });

  // ---------------------------------------------------------------
  // when hovering over a category, reveal its edit options
  // same for hovering over a site listing

  $('.mycat-header').hover(
     function () {
       $(this).children( "div.cat-edit-icons" ).addClass('show-icons');
     },
     function () {
       $(this).children( "div.cat-edit-icons" ).removeClass('show-icons');
     }
  );

  $('.mysite-header').hover(
     function () {
       $(this).find( ".site-edit-icons" ).addClass('show-icons');
     },
     function () {
       $(this).find( ".site-edit-icons" ).removeClass('show-icons');
     }
  );

  // ---------------------------------------------------------------
  // click a category's folder icon -> expand/collapse its sites

  $('.icon-plus-catname i.cat-bullet').on('click', function (event) {
    var node = $(this).attr('node');
    $(this).toggleClass('closed');
    $(this).toggleClass('fas');  /* switch between solid */
    $(this).toggleClass('far');  /* and outline          */
    $('.mycat-site-content[node=' + node + ']').toggleClass('closed');
  });

  $('i.favSite').on('click', function (event) {
    var id = $(this).attr('url');
    unfavSite(id);
  });

  $('.cat-bullet').removeClass('fas');   /* replace solid icon */
  $('.cat-bullet').addClass('far');      /* with outline icon  */

  // ---------------------------------------------------------------
  // Each default group icon will get this listener
  // When clicked, if I am not the default (hollow heart uses 'far')
  // then make me the default

  $("i.defaultGroupIcon").click(function() {

    if ($(this).hasClass('far')) {

      let groupId = $(this).attr('group');
      setDefaultGroup(groupId);
    }
  });

  openGroup($(`.startingGroup`).attr('group'));

  markDefaultGroup();

  checkMyBrowserSize();
});

function setDefaultGroup(newDefault) {

  let prevDefault = $('#groupTabs').attr('default');

  $.get(`/public/callapiasuser?call=editor/setdefaultgroup&groupId=${newDefault}`, function(data) {
    if (data == "OK") {

      // change and hide the default group icon for the prior default group
      $(`#groupTab${prevDefault} i`).removeClass('fas');
      $(`#groupTab${prevDefault} i`).addClass('far');
      $(`#groupTab${prevDefault} i`).hide();
      $(`#groupTab${prevDefault} i`).attr('title', makeDefaultText);

      // save the new default as an attribute of #groupTabs
      $('#groupTabs').attr('default', newDefault);

      markDefaultGroup();
    }
  });
}

function markDefaultGroup() {

  let groupId = $('#groupTabs').attr('default');

  if (groupId == 0) { groupId = $('#groupTabs div:first-child').attr('group'); }

  $(`#groupTab${groupId} i`).removeClass('far');  /* go from hollow */
  $(`#groupTab${groupId} i`).addClass('fas');     /* to solid       */
  
  /* openGroup shows the given group's default icon, but starting group  */
  /* may be different, so make sure to show the icon (and set the title) */
  $(`#groupTab${groupId} i`).attr('title', defaultGroupText);
  $(`#groupTab${groupId} i`).show();
}

$(document).mouseup(function (e) {

  // When clicking outside of the "New group" panel AND tab,
  // close both (doesn't matter if they were already closed)

  if ($(e.target).closest("#newGroupPanel").length === 0) { 
    if ($(e.target).closest("#groupAddTab").length === 0) { 
      $('.group-add-closeable').addClass('closed');
    }
  }
});

function setNonMobileScroll() {

  // When group tab section meets the bottom of the main menu, fix its position
  $(window).scroll(function() {
    $('#group-tab-inner').toggleClass('scroll-group-tab', $(window).scrollTop() > $('#group-tab-outer').offset().top - $('#nav-main-menu').height());
    $('#mypage-body').toggleClass('scroll-gap-adjust',   $('#group-tab-inner').hasClass('scroll-group-tab'));
    $('#newGroupPanel').toggleClass('scroll-gap-adjust', $('#group-tab-inner').hasClass('scroll-group-tab'));
    if ($('#group-tab-inner').hasClass('scroll-group-tab')) { $('#newGroupPanel').css({ 'top': '46px' }); }
    else { $('#newGroupPanel').css({ 'top': '100px' }); }
  });
}

function checkMyBrowserSize() {

  windowWidth      = window.outerWidth;
  var contentWidth = $('body').width();
  var sizeDiff     = windowWidth - contentWidth;
  actualSize       = windowWidth - sizeDiff;

  if (actualSize > 725) {
    setNonMobileScroll();
  }
}

